#! /usr/bin/env python2.5
# -*- coding: utf-8 -*-

import os
import sys

################################################################################
# Data management
################################################################################

# psuedo-enum
# source: http://stackoverflow.com/questions/36932/how-can-i-represent-an-enum-in-python
def enum(*sequential, **named):
    enums = dict(zip(sequential, range(len(sequential))), **named)
    reverse = dict((value, key) for key, value in enums.iteritems())
    enums['name'] = reverse
    return type('Enum', (), enums)


################################################################################
# File I/O
################################################################################

# validate the path to a (possibly nonexistent) file, creating any missing directories
def makePathTo(pathToFile):
	try:
		why = "Path exists"
		folder=os.path.dirname(pathToFile)
		if not os.path.exists(folder):  
			why = "Path created"
			os.makedirs(folder)
		return (True, why)
	except OSError, err:
		why = str(err)
		return (False, why)

# write data to file, creating any path members as necessary
def writeToFile(pathToFile, dataToWrite, writeMode):
	try:
		# validate the path to the file's parent directory; create any missing directories
		retVal = makePathTo(pathToFile)
		if not retVal[0]:
			return retVal
		
		f = open(pathToFile, writeMode)
		f.write(dataToWrite)
		return(True, "")
	except Exception, err:
		return (False, err)

# write CSV data to file, creating any path members as necessary, and adding the
# header to any newly-created files
def writeToCSVFile(pathToFile, dataToWrite, writeMode, header):
	try:
		# validate the path to the file's parent directory; create any missing directories
		retVal = makePathTo(pathToFile)
		if not retVal[0]:
			return retVal

		# check to see if the file exists.
		if not os.path.isfile(pathToFile):
			# if not, create it, and write the header
			writeToFile(pathToFile, header, 'w')
		
		# append the data to the existing file
		retVal = writeToFile(pathToFile, dataToWrite, 'a')
		return retVal
	except Exception, err:
		return (False, err)
		
# read from a file
def readFromFile(pathToFile, mode):
	try:
		f = open(pathToFile, mode)
		theData = f.read()
		return(True, theData)
	except Exception, err:
		return (False, err)

# return the absolute POSIX path to this this module
# source: http://stackoverflow.com/questions/2632199/how-do-i-get-the-path-of-the-current-executed-file-in-python?lq=1
def moduleDirectory():
    encoding = sys.getfilesystemencoding()
    if hasattr(sys, "frozen"):
        return os.path.dirname(unicode(sys.executable, encoding)) + "/"
    return os.path.dirname(unicode(__file__, encoding)) + "/"
